///<reference path="../modules/Data.ts" />

//@ts-ignore
const fs = require("fire-fs");

const panel = {
  // css style for panel
  style: fs.readFileSync(Editor.url(`packages://custom-component/page/index.css`)),

  // html template for panel
  template: fs.readFileSync(Editor.url(`packages://custom-component/page/index.html`)),

  // element and variable binding
  $: {
    btn: '#btn',
    label: '#label',
    uiPath: "#uiPath"
  },

  // method executed when template and styles are successfully loaded and initialized
  ready () {
    this.$btn.addEventListener("confirm", () => {
      Editor.Ipc.sendToMain("custom-component:clicked");

      // print method
      Editor.log("fs => ", JSON.stringify(Object.getOwnPropertyNames(fs)));
    });

    //@ts-ignore
    const data: Data = Editor.remote.CustomComponent.data;
    Editor.log("data.path >>>>> \n", data.path);
    this.$uiPath.value = `${data.path}`;
  },

  // register your ipc messages here
  messages: {
    "custom-component:hello" (event) {
      this.$label.innerText = "Hello...";
    }
  }
}

Editor.Panel.extend(panel);
